# Affirm OpenCart Extension

Please select the corresponding branch for your extension of OpenCart
## Installation

1. Go to Extensions > Extension Installer and click Upload.
2. Go to Extensions and select Payments from the dropdown.
3. Find the "Affirm" payment method and click the green Install button.

## Configure Affirm as a payment method

1. In the OpenCart admin, browse to Extensions > Extensions
2. Under Choose Extension Type, select Payments from the dropdown
3. Find the "Affirm" payment method and click the Edit icon
4. Configure the following settings:

* Enable Affirm - Set to True to enable Affirm as a payment method.
* Public API Key - Enter the public key from your Affirm sandbox dashboard.
* Private API Key - Enter the public key from your Affirm sandbox dashboard.
* Sandbox or Live Mode - Set to Sandbox for testing.
* Enable Affirm Modal Checkout - Set to True to have Affirm checkout in a modal window. Set to False to have the customer redirect to Affirm at checkout.
* Enable Affirm Enhanced Analytics - When a customer completes their purchase, you can send their order and product information to Affirm for A/B testing, which will help you optimize your site. Send this information by adding the Confirmation Page function to your payment confirmation page. 
* Transaction Method - Authorize Only: Obtains payment authorization only.  * Authorize + Capture: Obtains authorization and automatically captures funds.
* Authorization Order Status - If Transaction Method is Authorize Only, what order status should authorized Affirm orders have in OpenCart.
* Capture Order Status - If Transaction Method is Authorize + Capture, what order status should captured Affirm orders have in OpenCart.
* Minimum Order Total (optional) - The minimum order total for Affirm to be available at checkout. If blank, will default to $50.
* Maximum Order Total (optional) - The maximum order total for Affirm to be available at checkout. If blank, there is no maximum threshold.
* Default Currency - Set to USD.
* Debug/Logging - Set to False.
* Affirm Payments Accepted In - Set to USA.
* Sort Order - Refers to the order which Affirm will be placed at checkout (1 means it will be the top option).
5. Click Save before proceeding to the Promotional Messaging settings.

## Add Affirm promotional messaging
1. Check the checkbox next to Promotional Messaging Settings
2. Review the following settings:
* Promo Messaging Type - Select Logo, Symbol, or Text (default is Logo).
* Promo Messaging Color - Select color of Logo or Symbol (does not apply to Text).
* Enable Product Messaging - Set to True (required).
* Enable Shopping Cart Messaging - Set to True (required).
* Enable Mini Cart Messaging - Set to True to enable Affirm As Low As messaging on the mini-cart (optional).
* Enable Category Product Messaging - Set to True to enable Affirm As Low As messaging on the category page (optional).
* Enable Featured Product Messaging - Set to True to enable Affirm As Low As messaging on the featured product section (optional).
* Enable Best Selling Product Messaging - Set to True to enable Affirm As Low As messaging on the best selling product section (optional).
* Enable Latest Product Messaging - Set to True to enable Affirm As Low As messaging on the latest product section (optional).
* Enable Specials Product Messaging - Set to True to enable Affirm As Low As messaging on the specials page (optional).
* Enable Product Comparison Messaging - Set to True to enable Affirm As Low As messaging on the product comparison page (optional).
* Enable Manufacturer Product Messaging - Set to True to enable Affirm As Low As messaging on the manufacturer product page (optional).
* Enable Related Product Messaging - Set to True to enable Affirm As Low As messaging on the related product section (optional).
* Enable Checkout Confirmation Messaging - Set to True to enable Affirm As Low As messaging on the checkout confirmation (optional).
* Enable Homepage Banner - Set to True to place an Affirm banner on your homepage (optional).
* Set a Homepage Banner - If Enable Homepage Banner is true, select the appropriately sized .banner to display on the home page (optional).
3. Click Save.