<?php

/* Affirm 2019 */

class ControllerExtensionPaymentAffirm extends Controller {

    public function formatPrice($usd){ return number_format((float)$usd,2,'.','')*100; }
  
    public function index() {
        $data['platform_type'] = "OpenCart";
        $data['platform_version'] = "2.3.0.2";
        $data['platform_affirm'] = "1.0";
    
        $this->load->language('extension/payment/affirm');
        $this->load->model('extension/payment/affirm');
        $this->load->model('checkout/order');
        $this->load->model('catalog/category'); 
        $this->load->model('catalog/product');
    
        $data['affirm_public_key'] = $this->config->get('affirm_public_key');               
        $data['affirm_private_key'] = $this->config->get('affirm_private_key');
        $data['affirm_sandbox'] = $this->config->get('affirm_sandbox');
        $data['affirm_color'] = $this->config->get('affirm_color'); 
        $data['affirm_logo_data_type'] = $this->config->get('affirm_logo_data_type'); 
        $data['affirm_enhanced_analytics'] = $this->config->get('affirm_enhanced_analytics');
        $data['button_confirm'] = $this->language->get('button_confirm');
        if (!$this->config->get('affirm_sandbox') == 1) {
            $data['action'] = 'https://cdn1.affirm.com/js/v2/affirm.js';
        } else {
            $data['action'] = 'https://sandbox.affirm.com/js/v2/affirm.js';
        }
		
        $tax_amount = 0;
    
        $order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);

        if ($order_info) {
        $data['products'] = array();
        foreach ($this->cart->getProducts() as $product) {
            $option_data = array();
            foreach ($product['option'] as $option) {
                if ($option['type'] != 'file') {
                    $value = $option['value'];
                } 
                else {
                    $upload_info = $this->model_tool_upload->getUploadByCode($option['value']);
                    if ($upload_info) {
                        $value = $upload_info['name'];
                    } else {
                        $value = '';
                    }
                }

                $option_data[] = array(
                    'name'  => $option['name'],
                    'value' => (utf8_strlen($value) > 64 ? utf8_substr($value, 0, 64) . '..' : $value)
                );
            } 
            $data['store_name'] = $this->config->get('config_name');
            $image = $this->config->get('config_ssl')."image/".$product['image'];
            $data['products'][] = array(
                'name'     => htmlspecialchars($product['name']),
                'model'    => htmlspecialchars($product['model']),
                'price'    => $this->formatPrice($product['price']),
                'product_id' => $product['product_id'],
                'href'        => $this->url->link('product/product', 'product_id=' . $product['product_id']),
                'quantity' => $product['quantity'],  
                'item_image_url' => htmlspecialchars($image),
                'option'   => $option_data,
                'weight'   => $product['weight']
            );
            $data['adc'] = '';
            $categories = ""; $category = ""; $product_info = "";
            foreach($data['products'] as $products)
            {
                $categories = $this->model_catalog_product->getCategories($products['product_id']);
                foreach($categories as $c){
                    $category = $this->model_catalog_category->getCategory($c['category_id']);
                    if($c['category_id'] == $category['category_id']){ 
                        $product_info = $this->model_catalog_product->getProduct($products['product_id']);
                        if ($product_info['product_id'] == $product['product_id']) {
                            $data['product_categories'][] = array(
                                'category_id' => $c['category_id'],
                                'name'        => $category['name'], 
                                'sku'        => $product_info['sku'],
                                'product_id'        => $c['product_id']
                            );
                            $data['pro_categories'][] = array($category['name']);
                            $data['json_categories'] = $data['product_categories'];
                            $data['sku'] = $product_info['sku'];
                            $data['adc'] = json_encode($data['pro_categories']); 
                        }
                    }
                }
                }   
            }
            //print_r($data['product_categories']);exit;

            $data['discount_amount_cart'] = $this->formatPrice(0);
            $data['discount_title'] = null;  
            $data['discount_code'] = '';
            $data['coupon_title'] = null; 
            $data['coupon_code'] = null; 
            $data['coupon_amount_cart'] = $this->formatPrice(0);

            $total = $this->currency->format($order_info['total'] - $this->cart->getSubTotal(), 'USD', false, false);

            if ($total > 0) {
                $data['products'][] = array(
                    'name'     => $this->language->get('text_total'),
                    'product_id'    => '',
                    'model'    => '',
                    'price'    => $total,
                    'quantity' => 1,    
                    'item_image_url' => '',
                    'option'   => array(),
                    'weight'   => 0
                );
            } else {
                $data['discount_amount_cart'] -= $total;
            }

            $totals = $this->model_extension_payment_affirm->getOrderTotals($this->session->data['order_id']); 
            $total = ''; $total_code = ''; $sub_total = ''; $tax = ''; $shipping = ''; $shippingMethod = ''; $discountCode = ''; $discount = ''; $couponCode = ''; $discountTitle = ''; $couponTitle = ''; $coupon = '';

            foreach ($totals as $t){
            if($t['code'] == 'total'){ $total = $t['value']; $total_code = $t['code'];}
            if($t['code'] == 'sub_total'){ $sub_total = $t['value']; $total_code = $t['code'];}
            if($t['code'] == 'tax'){ if(is_numeric($t['value'])) { $tax += $t['value']; } $total_code = $t['code']; }
            if($t['code'] == 'shipping'){ $shipping = $t['value']; $total_code = $t['code'];}  
            if($t['code'] == 'coupon'){ $coupon = str_replace("-",'',$t['value']); $total_code = $t['code'];}  
            if($t['code'] == 'coupon'){ 
            $couponTitle = str_replace("Coupon ",'',$t['title']); 
            $total_code = $t['code'];
              if($total_code == 'coupon'){
                $this->load->model('extension/total/coupon');
                          $this->load->language('extension/total/coupon');
                $coupons = $this->model_extension_total_coupon->getCoupon($this->session->data['coupon']);
                if($coupons['code'] == $this->session->data['coupon']){
                   $couponTitle = $coupons['name']; 
                   $couponCode = $this->session->data['coupon'];
                } 
              }
            }

            if($t['code'] == 'voucher'){
            $discount = str_replace("-",'',$t['value']); 
            $discountTitle = $t['title']; 
            $total_code = $t['code'];
            $code = str_replace(')','',str_replace('Gift Certificate (','',$t['title']));
              if($total_code == 'voucher'){
                $this->load->model('extension/total/voucher');
                          $this->load->language('extension/total/voucher');
                $vouchers = $this->model_extension_total_voucher->getVoucher($code);

                if($vouchers['code'] == $code){
                   if($vouchers['message'] != ''){ 
                    $discountTitle = $vouchers['message'];
                    $discountCode = $vouchers['code']; 
                   } 
                   else { 
                    $discountTitle = $vouchers['theme'] .": + (". $vouchers['code'] .")";
                    $discountCode = $vouchers['code']; 
                  }
                } 
              }
            }
            if($t['code'] == 'shipping'){ $shippingMethod = $t['title']; $total_code = $t['code'];}


            } 
            if($total==null){$total='';}else{$total=$total;} 
            if($discount==null){$discount='';}else{$discount=$discount;}
            if($discountTitle==""){$discountTitle='';}else{$discountTitle=$discountTitle;} 
            if($discountCode==""){$discountCode='';}else{$discountCode=$discountCode;}   
            if($coupon==""){$coupon='';}else{$coupon=$coupon;}
            if($couponTitle==""){$couponTitle='';}else{$couponTitle=$couponTitle;}
            if($couponCode==""){$couponCode='';}else{$couponCode=$couponCode;}   
            $data['affirm_order_total'] = $this->formatPrice($total);
            if($discount!='' && $coupon != ''){
                $data['discount_amount_cart'] = $this->formatPrice($discount);
                $data['discount_title'] = $discountTitle;  
                $data['discount_code'] = $discountCode;
                $data['coupon_title'] = $couponTitle; 
                $data['coupon_code'] = $couponCode; 
                $data['coupon_amount_cart'] = $this->formatPrice($coupon);
            }
            if($discount == '' && $coupon != ''){
                $data['coupon_amount_cart'] = $this->formatPrice($coupon);
                $data['coupon_title'] = $couponTitle; 
                $data['coupon_code'] = $couponCode; 
            }
            if($discount!='' && $coupon == ''){
                $data['discount_amount_cart'] = $this->formatPrice($discount);
                $data['discount_title'] = $discountTitle;  
                $data['discount_code'] = $discountCode;

            }

            $data['shipping_first_name'] = html_entity_decode($order_info['shipping_firstname'], ENT_QUOTES, 'UTF-8');
            $data['shipping_last_name'] = html_entity_decode($order_info['shipping_lastname'], ENT_QUOTES, 'UTF-8');
            $data['shipping_address1'] = html_entity_decode($order_info['shipping_address_1'], ENT_QUOTES, 'UTF-8');
            $data['shipping_address2'] = html_entity_decode($order_info['shipping_address_2'], ENT_QUOTES, 'UTF-8');
            $data['shipping_city'] = html_entity_decode($order_info['shipping_city'], ENT_QUOTES, 'UTF-8');   
            $data['shipping_state'] = html_entity_decode($order_info['shipping_zone_code'], ENT_QUOTES, 'UTF-8');
            $data['shipping_zip'] = html_entity_decode($order_info['shipping_postcode'], ENT_QUOTES, 'UTF-8');
            $data['shipping_zone_code'] = html_entity_decode($order_info['shipping_zone_id'], ENT_QUOTES, 'UTF-8');
            $data['country'] = $order_info['payment_iso_code_2'];
            $data['email'] = $order_info['email'];
            $data['telephone'] = $order_info['telephone'];
            $data['total'] = $this->formatPrice($order_info['total']);
            $data['invoice'] = $this->session->data['order_id'];
            $data['lc'] = $this->session->data['language'];
            $data['cancel_return'] = $this->url->link('checkout/checkout', '', 'SSL');
            $data['confirm'] = $this->url->link('extension/payment/affirm/confirm', '', 'SSL');
            $data['amount'] = $this->formatPrice($order_info['total']); 
            $data['currency_code'] = $this->config->get('affirm_currency');
            $data['billing_first_name'] = html_entity_decode($order_info['payment_firstname'], ENT_QUOTES, 'UTF-8');
            $data['billing_last_name'] = html_entity_decode($order_info['payment_lastname'], ENT_QUOTES, 'UTF-8');
            $data['billing_address1'] = html_entity_decode($order_info['payment_address_1'], ENT_QUOTES, 'UTF-8');
            $data['billing_address2'] = html_entity_decode($order_info['payment_address_2'], ENT_QUOTES, 'UTF-8');
            $data['billing_city'] = html_entity_decode($order_info['payment_city'], ENT_QUOTES, 'UTF-8');      
            $data['billing_state'] = html_entity_decode($order_info['payment_zone_code'], ENT_QUOTES, 'UTF-8');
            $data['billing_zip'] = html_entity_decode($order_info['payment_postcode'], ENT_QUOTES, 'UTF-8');
            $data['billing_zone_code'] = html_entity_decode($order_info['payment_zone_id'], ENT_QUOTES, 'UTF-8');
            $sub_total  = $order_info['total'];
            $cart_total = $this->cart->getSubTotal();
            $data['tax_amount'] = $this->formatPrice($tax);
            if(isset($shipping)){
                $data['shipping_amount'] = $this->formatPrice($shipping);
            }
            else
            {
                $data['shipping_amount'] = '0';
            }
            $data['order_id'] = $this->session->data['order_id'];
            $data['payment_method_code'] = $this->session->data['payment_method']['code'];

            // Merchant or Admin user session token
            $data['token'] = '';
            if(isset($this->session->data['token'])){ $data['token'] = $this->session->data['token']; }
            else{ $data['token'] = ''; }

            // Modal Checkout option
            if($this->config->get('affirm_modal_checkout') == 1){ $data['modal_checkout'] = $this->language->get('text_affirm_checkout_mode_modal'); }
            else{ $data['modal_checkout'] = $this->language->get('text_affirm_checkout_mode_redirect'); } 

            if(isset($this->session->data['shipping_method'])){
                $data['shipping_type'] = $this->session->data['shipping_method']['title'];
            }
            else{
                $data['shipping_type'] = null; 
            }
            if (file_exists(DIR_TEMPLATE . $this->config->get('config_template') . 'extension/payment/affirm')) {
                return $this->load->view($this->config->get('config_template') . 'extension/payment/affirm', $data);
            } else {
                return $this->load->view('extension/payment/affirm', $data);
            }
        }
    }
	
    public function confirm() {
        if ($this->session->data['payment_method']['code'] == 'affirm') { 
            $this->load->model('extension/payment/affirm'); 
            $this->load->language('extension/payment/affirm');
            $this->load->model('checkout/order');
            $checkout_token = $_REQUEST["checkout_token"];
            if($checkout_token == '' || !isset($checkout_token)){
                //fail
                $continue = $this->url->link('checkout/checkout');
                header("Location: $continue");
            }
            else
            {
                //success
                $orderId = $this->session->data['order_id'];
                $chargeId = $this->model_extension_payment_affirm->createCharge($checkout_token, $this->session->data['order_id']);
                $transaction = $this->config->get('affirm_transaction'); 
                $capture_id = $this->config->get('affirm_order_capture_status_id');
                $capture_title = $this->language->get('text_capture'); 
                $auth_id = $this->config->get('affirm_order_status_id');      
                $auth_title = $this->language->get('text_authorization');
                if($transaction == 0){
                    if(isset($this->session->data['shipping_method'])){ 
                        $shipping_method = $this->session->data['shipping_method']['title'];
                    } 
                    else{ 
                        $shipping_method = "Not set"; 
                    } 
                    $this->model_extension_payment_affirm->captureCharge($this->session->data['order_id'],$shipping_method,null); 
                    $this->model_checkout_order->addOrderHistory($this->session->data['order_id'], $capture_id); 
                    $continue = $this->url->link('checkout/success');
                    header("Location: $continue");   
                }
                else{
                    $this->model_checkout_order->addOrderHistory($this->session->data['order_id'], $auth_id); 
                    $continue = $this->url->link('checkout/success');
                    header("Location: $continue");   
                }
            }
        }
    }
  
    public function addChargeToDB($data) {
        $insert = array(
        'order_id' => (int)$data['order_id'],
        'charge_id' => "'" . $this->db->escape($data['charge_id']) . "'",
        'date_added' => "'" . $this->db->escape($data['created']) . "'",
        'type' => "'" . $this->db->escape($data['type']) . "'",
        'status' => "'" . $this->db->escape($data['status']) . "'",
        'amount' => (float)$data['amount']
        );
        $row = array();
        foreach ($insert as $key => $value) {
            $row[] = "`" . $key . "`=" . $value;
        }
        $this->db->query("INSERT INTO `" . DB_PREFIX . "affirm_order` SET " . implode(',', $row));
    }
}